#ifndef PARAMS_H
#define PARAMS_H

#include "config.h"


#define SEEDBYTES 32
#define CRHBYTES 64

#define ROOT_OF_UNITY 1753

#if NIMS_TRI_NTT_MODE == 1
#define N 1152
#define P 1152
#define NR 1152
#define Q 8401537
#define D 12
#define ETA 1
#define TAU 25
#define BETA 50
#define GAMMA1 (1<<18)
#define GAMMA2 131274
#define OMEGA 80
#elif NIMS_TRI_NTT_MODE == 3
#define N 1536
#define P 1536
#define NR 1536 
#define Q 8397313
#define D 12
#define ETA 1
#define TAU 29
#define BETA 58
#define GAMMA1 (1<<18)
#define GAMMA2 131208
#define OMEGA 80
#elif NIMS_TRI_NTT_MODE == 5
#define N 2304
#define P 2304
#define NR 2304 
#define Q 8404993
#define D 13
#define ETA 1
#define TAU 32
#define BETA 64
#define GAMMA1 (1<<19)
#define GAMMA2 262656
#define OMEGA 80
#endif

// #if NIMS_MODE == 2
// #define N 1021
// #define P 1021
// #define NR 1024
// #define Q 8339581
// #define D 11
// #define ETA 2
// #define TAU 25
// #define BETA 100
// #define GAMMA1 (1 << 17)
// #define GAMMA2 ((Q-1)/90)
// #define OMEGA 80
// #elif NIMS_MODE == 3
// #define N 1429
// #define P 1429
// #define NR 1440
// #define Q 8376649
// #define D 12
// #define ETA 2
// #define TAU 29
// #define BETA 116
// #define GAMMA1 (1 << 18)
// #define GAMMA2 ((Q-1)/56)
// #define OMEGA 80
// #elif NIMS_MODE == 5
// #define N 1913
// #define P 1913
// #define NR 1920
// #define Q 8343469
// #define D 12
// #define ETA 2
// #define TAU 32
// #define BETA 128
// #define GAMMA1 (1 << 19)
// #define GAMMA2 ((Q-1)/42)
// #define OMEGA 80
// #endif
// #if NIMS_TRI_MODE == 2
// #define N 1024
// #define P 1024
// #define NR 1024
// #define Q (1 << 23)
// #define D 12
// #define ETA 2
// #define TAU 25
// #define BETA 100
// #define GAMMA1 (1 << 18)
// #define GAMMA2 (1 << 17)
// #define OMEGA 80
// #elif NIMS_TRI_MODE == 3
// #define N 1458
// #define P 1458
// #define NR 1536 //1472였음.. 128배수(8(AVX2) * 4(TC4W) * 4(karatsuba)) 되게 하기 위해 변경
// #define Q (1 << 23)
// #define D 12
// #define ETA 2
// #define TAU 29
// #define BETA 116
// #define GAMMA1 (1 << 18)
// #define GAMMA2 (1 << 17)
// #define OMEGA 80
// #elif NIMS_TRI_MODE == 5
// #define N 1944
// #define P 1944
// #define NR 2048 //1920였음.. 128배수(8(AVX2) * 4(TC4W) * 4(karatsuba)) 되게 하기 위해 변경
// #define Q (1 << 23)
// #define D 13
// #define ETA 2
// #define TAU 32
// #define BETA 128
// #define GAMMA1 (1 << 19)
// #define GAMMA2 (1 << 18)
// #define OMEGA 80
// #endif


//packing bytes define

#define POLYT1_PACKEDBYTES      ((N*(24-D))/8)
#define POLYT0_PACKEDBYTES      ((N*D)/8)
#define POLYH_PACKEDBYTES    (N/8)

#if (N==2304)
#define POLYZ_PACKEDBYTES       ((N*20)/8)
#else
#define POLYZ_PACKEDBYTES       ((N*19)/8)
#endif

#if (N==2304)
#define POLYW1_PACKEDBYTES      ((N*4)/8)
#else
#define POLYW1_PACKEDBYTES      ((N*5)/8)
#endif

#define POLYETA_PACKEDBYTES     ((N*3)/8)

// #if (N==1458)
// #define POLYT1_PACKEDBYTES      (((N*(23-D+1)+7)/8))
// #else
// #define POLYT1_PACKEDBYTES      (((N*(23-D+1))/8))
// #endif
// #define POLYT0_PACKEDBYTES      ((N*D)/8)
// #if (N==1458)
// #define POLYH_PACKEDBYTES    ((N+7)/8)
// #else
// #define POLYH_PACKEDBYTES    (N/8)
// #endif
// #if (N==1024)
// #define POLYZ_PACKEDBYTES       ((N*19)/8)
// #elif (N==1458)
// #define POLYZ_PACKEDBYTES       (((N*19)+7)/8)
// #elif (N==1944)
// #define POLYZ_PACKEDBYTES       ((N*20)/8)
// #endif
// #if (N==1024)
// #define POLYW1_PACKEDBYTES      ((N*5)/8)
// #elif (N==1458)
// #define POLYW1_PACKEDBYTES      (((N*5)+7)/8)
// #elif (N==1944)
// #define POLYW1_PACKEDBYTES      ((N*4)/8)
// #endif
// #if (N==1458)
// #define POLYETA_PACKEDBYTES     (((N*3)+7)/8)
// #else
// #define POLYETA_PACKEDBYTES     ((N*3)/8)
// #endif

#define CRYPTO_PUBLICKEYBYTES   (SEEDBYTES + POLYT1_PACKEDBYTES)
#define CRYPTO_SECRETKEYBYTES   (3*SEEDBYTES\
                                + 2*POLYETA_PACKEDBYTES\
                                + POLYT0_PACKEDBYTES)
#define CRYPTO_BYTES            (SEEDBYTES + POLYZ_PACKEDBYTES + POLYH_PACKEDBYTES)

#endif
